@echo off
setlocal enableextensions enabledelayedexpansion

chcp 1251 > nul

for /f "tokens=2 delims==" %%i in ('wmic os get localdatetime /value') do set datetime=%%i
set Year=%datetime:~0,4%

:: Specifying the path to the file
set "configFile=C:\Users\Public\Documents\Andersen\MedVisor\medvisor.config"

:: Define a regular expression, replacing questionable symbols with a dot
set "searchRegex=connectionString=.*data source=.*MedVisorDatabase.sdf"

set SQLServer=.\SQLEXPRESS
set "MedVisorDatabase=1"
set dataSource=" "  
set "DatabaseBackup=C:\Users\Public\Documents\Andersen\MedVisor\Database\Medvisor-%Year%.bak"
set "MedVisorDatabasePath=none"

echo.
echo If you do not wish to continue running this program, simply close the window.
echo.
echo Deleting ALL photos of ALL patients that are not included in any protocol and are only stored in the patient's history.

if exist "C:\Program Files\Microsoft SQL Server\110\Tools\Binn\osql.exe" set ProgrammPath="C:\Program Files\Microsoft SQL Server\110\Tools\Binn\sqlcmd.exe"
if exist "C:\Program Files\Microsoft SQL Server\150\Tools\Binn\osql.exe" set ProgrammPath="C:\Program Files\Microsoft SQL Server\150\Tools\Binn\sqlcmd.exe"
if exist "C:\Program Files\Microsoft SQL Server\160\Tools\Binn\osql.exe" set ProgrammPath="C:\Program Files\Microsoft SQL Server\Client SDK\ODBC\170\Tools\Binn\sqlcmd.exe"

if not exist "%configFile%" (
    echo File "%configFile%" not found!
    pause
    exit /b 1
)

echo.>report.txt

findstr /r /c:"%searchRegex%" "%configFile%" >config.txt
if %errorlevel% equ 0 (
    for /f "delims=" %%A in ('findstr "data source=" "config.txt"') do (
        set "line=%%A"
        set line=!line:~62,80!
        for /f "tokens=1 delims==;" %%B in ("!line!") do (
            set "MedVisorDatabase=%%B"
        )
    )
    for %%A in ("!MedVisorDatabase!") do (
      set "MedVisorDatabasePath=%%~dpA"
    )
    set "DatabaseBackup=!MedVisorDatabasePath:~0,-1!\Medvisor-%Year%.sdf"

    echo The current database will be saved in the file !DatabaseBackup!.
    echo To access the saved database from the Medvisor application, use the file name 
    echo !DatabaseBackup!
    call "Size of Database SDF.bat"
    echo.
    pause

    echo.>> report.txt
    Echo Database: !MedVisorDatabase!>> report.txt
    echo.>> report.txt
    
    if exist !DatabaseBackup! (echo.
        echo The backup %DatabaseBackup% already exists.
        echo Move the file to another location or rename it.
        pause
        exit /b 1
    )
    echo Creating a backup of the database !MedVisorDatabase!...
    copy /y !MedVisorDatabase! !DatabaseBackup!
    if exist !MedVisorDatabase! (echo Generating a list of patient photos that are not included in protocols and will be deleted...
        SqlCeCmd40.exe -d "Data Source=!MedVisorDatabase!; Max Database Size = 4091" -i ".\List of photos of patients.sdf" >> report.txt
        echo Deleting patient photos...
        SqlCeCmd40.exe -d "Data Source=!MedVisorDatabase!; Max Database Size = 4091" -i ".\Delete ALL Photos patients.sdf" >> report.txt
        echo Compacting the database...
        SqlCeCmd40.exe -d "Data Source=!MedVisorDatabase!; Max Database Size = 4091" -e compact >>report.txt
        call "Size of Database SDF.bat"
    ) else (echo.
        echo Failed to create a backup of the database.
        echo Operation not completed.
    )
) else (
    echo The current database will be saved in the database Medvisor-%Year%.
    echo To access the saved database from the Medvisor application, use the database name Medvisor-%Year%.
    echo.
    pause

    if exist !DatabaseBackup! (echo.
        echo The backup %DatabaseBackup% already exists
        echo Move the file to another location or rename it
        pause
        exit /b 1
    )
    echo Creating a backup of the database Medvisor-%Year%...
    %ProgrammPath% -S %SQLServer% -U sa -P 1qaz2WSX -i ".\Create Backup Base Medvisor-YYYY.sql" -f 65001 >> report.txt
    if exist %DatabaseBackup% (echo Generating a list of patient photos that are not included in protocols and will be deleted...
        %ProgrammPath% -S %SQLServer% -U sa -P 1qaz2WSX -i ".\List of photos of patients.sql" -f 65001 >> report.txt
        echo Deleting patient photos...
        %ProgrammPath% -S %SQLServer% -U sa -P 1qaz2WSX -i ".\Delete ALL Photos patients.sql" -f 65001 >> report.txt
        echo Photos deleted successfully. The original database is saved in %DatabaseBackup%. 
        echo To access the archived database from the Medvisor application, use the database name Medvisor-%Year%
    ) else (echo.
        echo Failed to create a backup of the database.
        echo Operation not completed.
    )
)
echo The result is in the file report.txt
echo.
pause
