--    "Medvisor-"
DECLARE @Year NVARCHAR(4) = CONVERT(NVARCHAR(4), YEAR(GETDATE()));
DECLARE @DBName NVARCHAR(128) = N'Medvisor-' + @Year;
DECLARE @SQL NVARCHAR(MAX);

IF NOT EXISTS (SELECT name FROM sys.databases WHERE name = @DBName)
BEGIN
    SET @SQL = N'
    CREATE DATABASE [' + @DBName + N']
     CONTAINMENT = NONE
     ON  PRIMARY 
    ( NAME = N''' + @DBName + N''', FILENAME = N''C:\Program Files\Microsoft SQL Server\MSSQL16.SQLEXPRESS\MSSQL\DATA\' + @DBName + N'.mdf'' , SIZE = 8192KB , FILEGROWTH = 65536KB )
     LOG ON 
    ( NAME = N''' + @DBName + N'_log'', FILENAME = N''C:\Program Files\Microsoft SQL Server\MSSQL16.SQLEXPRESS\MSSQL\DATA\' + @DBName + N'_log.ldf'' , SIZE = 8192KB , FILEGROWTH = 65536KB );

    ALTER DATABASE [' + @DBName + N'] SET ANSI_NULL_DEFAULT OFF;
    ALTER DATABASE [' + @DBName + N'] SET ANSI_NULLS OFF;
    ALTER DATABASE [' + @DBName + N'] SET ANSI_PADDING OFF;
    ALTER DATABASE [' + @DBName + N'] SET ANSI_WARNINGS OFF;
    ALTER DATABASE [' + @DBName + N'] SET ARITHABORT OFF;
    ALTER DATABASE [' + @DBName + N'] SET AUTO_CLOSE OFF;
    ALTER DATABASE [' + @DBName + N'] SET AUTO_SHRINK OFF;
    ALTER DATABASE [' + @DBName + N'] SET AUTO_CREATE_STATISTICS ON (INCREMENTAL = OFF);
    ALTER DATABASE [' + @DBName + N'] SET AUTO_UPDATE_STATISTICS ON;
    ALTER DATABASE [' + @DBName + N'] SET CURSOR_CLOSE_ON_COMMIT OFF;
    ALTER DATABASE [' + @DBName + N'] SET CURSOR_DEFAULT GLOBAL;
    ALTER DATABASE [' + @DBName + N'] SET CONCAT_NULL_YIELDS_NULL OFF;
    ALTER DATABASE [' + @DBName + N'] SET NUMERIC_ROUNDABORT OFF;
    ALTER DATABASE [' + @DBName + N'] SET QUOTED_IDENTIFIER OFF;
    ALTER DATABASE [' + @DBName + N'] SET RECURSIVE_TRIGGERS OFF;
    ALTER DATABASE [' + @DBName + N'] SET DISABLE_BROKER;
    ALTER DATABASE [' + @DBName + N'] SET AUTO_UPDATE_STATISTICS_ASYNC OFF;
    ALTER DATABASE [' + @DBName + N'] SET DATE_CORRELATION_OPTIMIZATION OFF;
    ALTER DATABASE [' + @DBName + N'] SET PARAMETERIZATION SIMPLE;
    ALTER DATABASE [' + @DBName + N'] SET READ_COMMITTED_SNAPSHOT OFF;
    ALTER DATABASE [' + @DBName + N'] SET READ_WRITE;
    ALTER DATABASE [' + @DBName + N'] SET RECOVERY SIMPLE;
    ALTER DATABASE [' + @DBName + N'] SET MULTI_USER;
    ALTER DATABASE [' + @DBName + N'] SET PAGE_VERIFY CHECKSUM;
    ALTER DATABASE [' + @DBName + N'] SET TARGET_RECOVERY_TIME = 60 SECONDS;
    ALTER DATABASE [' + @DBName + N'] SET DELAYED_DURABILITY = DISABLED;

    ALTER DATABASE SCOPED CONFIGURATION SET LEGACY_CARDINALITY_ESTIMATION = Off;
    ALTER DATABASE SCOPED CONFIGURATION FOR SECONDARY SET LEGACY_CARDINALITY_ESTIMATION = Primary;
    ALTER DATABASE SCOPED CONFIGURATION SET MAXDOP = 0;
    ALTER DATABASE SCOPED CONFIGURATION FOR SECONDARY SET MAXDOP = PRIMARY;
    ALTER DATABASE SCOPED CONFIGURATION SET PARAMETER_SNIFFING = On;
    ALTER DATABASE SCOPED CONFIGURATION FOR SECONDARY SET PARAMETER_SNIFFING = Primary;
    ALTER DATABASE SCOPED CONFIGURATION SET QUERY_OPTIMIZER_HOTFIXES = Off;
    ALTER DATABASE SCOPED CONFIGURATION FOR SECONDARY SET QUERY_OPTIMIZER_HOTFIXES = Primary;

    IF NOT EXISTS (SELECT name FROM sys.filegroups WHERE is_default = 1 AND name = N''PRIMARY'') 
    ALTER DATABASE [' + @DBName + N'] MODIFY FILEGROUP [PRIMARY] DEFAULT;
    ';
    EXEC sp_executesql @SQL;
END

SET @SQL = N'USE [' + @DBName + N'];';
EXEC sp_executesql @SQL;

--    Medvisor
DECLARE @BackupFile NVARCHAR(MAX);
DECLARE @SqlCommand NVARCHAR(MAX);

SET @BackupFile = N'C:\Users\Public\Documents\Andersen\MedVisor\Database\Medvisor-' + @Year + N'.bak';
SET @SqlCommand = N'BACKUP DATABASE [Medvisor] ' +
                  N'TO DISK = ''' + @BackupFile + ''' ' +
                  N'WITH FORMAT, INIT, NAME = ''Medvisor Backup'', STATS = 10;';
EXEC sp_executesql @SqlCommand;

--    "Medvisor-"
DECLARE @DatabaseName NVARCHAR(128);
DECLARE @DataFile NVARCHAR(MAX);
DECLARE @LogFile NVARCHAR(MAX);

SET @DataFile = N'C:\Program Files\Microsoft SQL Server\MSSQL16.SQLEXPRESS\MSSQL\DATA\' + @DBName + N'.mdf';
SET @LogFile = N'C:\Program Files\Microsoft SQL Server\MSSQL16.SQLEXPRESS\MSSQL\DATA\' + @DBName + N'_log.ldf';

RESTORE DATABASE @DBName
FROM DISK = @BackupFile
WITH MOVE N'Medvisor' TO @DataFile, 
     MOVE N'Medvisor_log' TO @LogFile,
     REPLACE, STATS = 10;

SET @SQL = N'
USE [' + @DBName + N']
ALTER ROLE [db_backupoperator] ADD MEMBER [medvisor_client]
ALTER ROLE [db_datareader] ADD MEMBER [medvisor_client]
ALTER ROLE [db_datawriter] ADD MEMBER [medvisor_client]
';
EXEC sp_executesql @SQL;

