USE [MedVisor]
GO

SELECT 
    Substring(DB_NAME(database_id),1,15) AS Database_Name,
    SUM(CASE WHEN type = 0 THEN size * 8 ELSE 0 END) / 1024 AS DataSize_MB,
    SUM(CASE WHEN type = 0 THEN size * 8 ELSE 0 END)*100 / (10*1024*1024) AS Size_Proc_Of_Max
FROM 
    sys.master_files
WHERE 
    DB_NAME(database_id) = 'Medvisor'
GROUP BY 
    database_id;
Go

SELECT '';

SELECT COUNT(AppointmentPictures.Id) AS AppointmentPicturesCount, Substring(People.LastName,1,15), Substring(People.FirstName,1,15), Substring(People.MiddleName,1,15)
FROM AppointmentPictures INNER JOIN
     Appointments ON AppointmentPictures.AppointmentId = Appointments.Id INNER JOIN
     Patients ON Appointments.PatientId = Patients.Id INNER JOIN
     People ON Patients.Id = People.Id
WHERE AppointmentPictures.ProtocolType = 0
GROUP BY Patients.Id, People.Id, People.LastName, People.FirstName, People.MiddleName, Appointments.AppointmentNumber
HAVING COUNT(AppointmentPictures.Id) > 5
ORDER BY AppointmentPicturesCount DESC
GO